package lutadebonecos;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import JPlay.Sound;
import java.util.LinkedList;

/**
 * @author Gefersom Cardoso Lima
 * Universidade Federal Fluminense - UFF - Brasil - 2010
 * Ciência da Computação
 */

public class ControladorTiros
{
    LinkedList<Tiro> objetos = new LinkedList<Tiro>();

    public void addTiro(String nomeImagem, double x, double y,int floor, char sentido)
    {
            Tiro tiro = new Tiro(nomeImagem, x, y);
            tiro.setStateOfX(sentido);
            tiro.setFloor(floor);

            //Adiciona o objeto na começo da lista
            addTiro(tiro);
    }

    public void addTiro(Tiro tiro)
    {
            objetos.addLast(tiro);            
    }

    public void step(int floor)
    {
            for(int i=0; i < objetos.size(); i++)
            {
                    Tiro tiro = objetos.removeFirst();
                    tiro.moveX();
                    tiro.runAnimation();

                    //Se o tiro não tocou o chão, não tocou a parede da esquerda ou
                    //não tocou a parede da direita, então, adiciona novamente a lista de tiros
                    if ( tiro.isOnFloor() == false && tiro.x > 1 && tiro.x + tiro.width < 800)
                    {
                        tiro.fall();
                        objetos.addLast(tiro);
                    }
                    else
                    {
                        //O tiro não passou em alguns dos testes acima
                        Sound explosao = new Sound("explosao.wav");
                        explosao.play();
                    }
            }
    }

    //Desenha os tiros na tela
    public void draw()
    {
            for(int i=0; i < objetos.size(); i++)
            {
                    Tiro tiro = objetos.removeFirst();
                    tiro.draw();
                    objetos.addLast(tiro);
            }
    }

    public int quantidadeDeTiros()
    {
            return objetos.size();
    }

    public Tiro remover()
    {
            return objetos.removeFirst();
    }
}
