/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package lutadebonecos;

import JPlay.Animation;
import JPlay.GameImage;
import JPlay.Keyboard;
import JPlay.Sound;
import JPlay.Sprite;
import JPlay.Window;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.KeyEvent;

/**
 * @author Gefersom Cardoso Lima
 * Universidade Federal Fluminense - UFF - Brasil - 2010
 * Ciência da Computação
 */

public class LutaDeBonecos
{
    Window window;
    Boneco bonecoAzul;
    Boneco bonecoVermelho;
    Keyboard keyboard;
    GameImage fundoDaTela;
    ControladorTiros tirosBonecoAzul;
    ControladorTiros tirosBonecoVermelho;
    int pontuacaoBonecoVermelho;
    int pontuacaoBonecoAzul;
    GameImage vidaAzul;
    GameImage vidaVermelha;
    String bonecoQueVenceu;
    Animation animacaoBonecoGanhou;
    long delayParaApresentarAnimacao;
    Sound musica;
    Font fonte;
    int floor;

    public LutaDeBonecos()
    {
            carregarObjetos();
            setarConfiguracoes();
            loop();
            descarregarObjetos();
    }

    private void carregarObjetos()
    {
            window = new Window(800, 600);
            bonecoAzul = new Boneco("bonecoAzul.png");
            bonecoVermelho = new Boneco("bonecoVermelho.png");
            keyboard = window.getKeyboard();
            fundoDaTela = new GameImage("fundo.png");
            tirosBonecoAzul = new ControladorTiros();
            tirosBonecoVermelho = new ControladorTiros();

            vidaAzul = new GameImage("barraAzul.png");
            vidaVermelha = new GameImage("barraVermelha.png");

            animacaoBonecoGanhou = new Animation("megaManGanhou.png",8);
            musica = new Sound("musica.wav");

            bonecoQueVenceu = "";

            fonte = new Font("Comic Sans MS", Font.TRUETYPE_FONT, 40);
    }

    private void descarregarObjetos()
    {
            bonecoAzul = null;
            bonecoVermelho = null;
            keyboard = null;
            fundoDaTela = null;
            tirosBonecoAzul = null;
            tirosBonecoVermelho = null;
            vidaAzul = null;
            vidaVermelha = null;
            window.exit();
    }
    
    private void setarConfiguracoes()
    {
            //Seta o valor do chão, coordenada y, a qual o boneco não irá ultrapassar
            bonecoAzul.setFloor(500);            
            bonecoAzul.x = 600;

            //Seta o valor do chão, coordenada y, a qual o boneco não irá ultrapassar
            bonecoVermelho.setFloor(500);
            bonecoVermelho.x = 70;
            bonecoVermelho.setStateOfX(Sprite.RIGHT);

            keyboard.addKey(KeyEvent.VK_A, Keyboard.DETECT_EVERY_PRESS);
            keyboard.addKey(KeyEvent.VK_D, Keyboard.DETECT_EVERY_PRESS);
            keyboard.addKey(KeyEvent.VK_S, Keyboard.DETECT_INITIAL_PRESS_ONLY);
            keyboard.addKey(KeyEvent.VK_W, Keyboard.DETECT_INITIAL_PRESS_ONLY);

            //Mudamos o comportamento da tecla para que o boneco não der titos excessivos
            keyboard.setBehavior(Keyboard.DOWN_KEY, Keyboard.DETECT_INITIAL_PRESS_ONLY);

            vidaAzul.setPosition(710, 120);
            vidaVermelha.setPosition(100, 120);

            animacaoBonecoGanhou.setPosition(320,380);
            animacaoBonecoGanhou.setTimeChangeFrame(100);//100ms = 0.1s = tempo de mudança entre os frames

            musica.setRepeat(true);//faz a música ser executada continuamente
            musica.setVolume(-10);//diminui o volume da música em 10 unidades

            this.floor = 500;
    }

    //É no loop onde todo o jogo se desenvolverá
    private void loop()
    {
           musica.play();

           boolean executando = true;
           boolean acabou = false;
           while(executando)
           {
                   if (bonecoQueVenceu.equals("") == true)
                   {
                            desenhar();
                            atualizacoes();                            
                            window.delay(10);//Atraso de 10 ms
                   }
                   else
                   {                           
                           if (acabou == false)
                           {
                                //Seta uma nova fonte
                                window.setFont(fonte);
                                acabou = true;
                                
                                //A animação só se repetirá uma vez
                                animacaoBonecoGanhou.setRepeatAnimation(false);
                                if (bonecoQueVenceu.equals("vermelho"))
                                    animacaoBonecoGanhou.setRangeOfFrames(5, 8);
                                else
                                    animacaoBonecoGanhou.setRangeOfFrames(0, 4);
                           }
                           lutaTerminou();
                   }

                    //Se apertar ESC o jogo se encerra
                    if (keyboard.keyDown(Keyboard.ESCAPE_KEY))
                        executando = false;
           }
    }

    private void lutaTerminou()
    {

            //window.timeElapsed() - retorna o tempo passado entre entre o frame
            //anterior e o atual.
            delayParaApresentarAnimacao += window.timeElapsed();

            //Se passou 0.5 segundos depois que houve a vitória, então, roda a animação
            //500ms = 0.5s
            if (delayParaApresentarAnimacao > 500)
                animacaoBonecoGanhou.runAnimation(); //Executa a animação

            fundoDaTela.draw();
            animacaoBonecoGanhou.draw();
            
            if (bonecoQueVenceu.equals("vermelho"))
                window.drawText("VERMELHO VENCEU!", 210, 300, Color.RED);
            else
                window.drawText("AZUL VENCEU!", 250, 300, Color.CYAN);
            animacaoBonecoGanhou.draw();
            window.display();
    }

    private void desenhar()
    {
            //Parte responsável por desenhar na tela
            fundoDaTela.draw();
            bonecoAzul.draw();
            bonecoVermelho.draw();
            tirosBonecoAzul.draw();
            tirosBonecoVermelho.draw();
            vidaAzul.draw();
            vidaVermelha.draw();

            window.drawText("Pontuacao: " + pontuacaoBonecoVermelho, 650, 100, Color.BLUE);
            window.drawText("Pontuacao: " + pontuacaoBonecoAzul, 100, 100, Color.RED);

            window.drawText("Vermelho: teclas W, S, A, D", 100, 50, Color.RED);
            window.drawText("Azul: setas UP, DOWN, LEFT, RIGHT", 530, 50, Color.BLUE);

            //esse método SEMPRE deve ser chamado por último na parte de desenho
            window.display();
    }

    private void atualizacoes()
    {
            bonecoAzul.setarSpritesSentidoLocomocao();
            bonecoAzul.moveX();//usa as setas direcionais para os lados
            bonecoAzul.jump(KeyEvent.VK_UP);//usa a seta para cima para pular

            bonecoVermelho.setarSpritesSentidoLocomocao();
            bonecoVermelho.moveX(KeyEvent.VK_A, KeyEvent.VK_D);
            bonecoVermelho.jump(KeyEvent.VK_W);

            tirosBonecoVermelho.step(500);
            tirosBonecoAzul.step(500);

            if (keyboard.keyDown(KeyEvent.VK_S))
                addTiro(bonecoVermelho, tirosBonecoVermelho, "tiroVermelho.png");

            if (keyboard.keyDown(Keyboard.DOWN_KEY))
                addTiro(bonecoAzul, tirosBonecoAzul, "tiroAzul.png");

            //Retorna true se o boneco Azul levou algum tiro, ao contrário, false
            if (bonecoLevouTiro(bonecoAzul, tirosBonecoVermelho))
            {
                    pontuacaoBonecoVermelho++;
                    vidaAzul.height -= 13;
            }

            //Retorna true se o boneco Vermelho levou algum tiro, ao contrário, false
            if (bonecoLevouTiro(bonecoVermelho, tirosBonecoAzul))
            {
                    pontuacaoBonecoAzul++;
                    vidaVermelha.height -= 13;
            }

            //A medida que o boneco leva tiros diminuimos a altura do objeto vidaAzul
            //ou vidaVermelha, dando a sensação de que o boneco está perdendo vida.
            if (vidaAzul.height < 1)
                bonecoQueVenceu = "vermelho" ;
            else
                if (vidaVermelha.height < 1)
                    bonecoQueVenceu = "azul";
    }

    private void addTiro(Boneco boneco, ControladorTiros tiros, String nomeImagem)
    {            
            //Se o boneco estiver virado para a direita,
            //posiciona o tiro na coordenada 'x + width' do boneco e na metada da sua altura
            if ( boneco.getSentido() == Sprite.RIGHT)
            {
                //tiros.addTiro(posicaoX, posicaoY, sentido)
                tiros.addTiro(nomeImagem, boneco.x + boneco.width -30, boneco.y + boneco.height/2, floor, Sprite.RIGHT);
            }
            else
            {
                //Se o boneco estiver virado para a esquerda,
                //posiciona o tiro na coordenada 'x' do boneco e na metada da sua altura
                tiros.addTiro(nomeImagem, boneco.x, boneco.y + boneco.height/2, floor, Sprite.LEFT);
            }
            new Sound("muzzleshot.wav").play();
    }

    
    private boolean bonecoLevouTiro(Boneco boneco, ControladorTiros tirosInimigos)
    {
            boolean bonecoSofreuTiro = false;
            for (int i=0; i < tirosInimigos.quantidadeDeTiros(); i++)
            {
                    //Remove um tiro da lista de tiros, sendo o removido o primeiro da lista
                    Tiro tiro = tirosInimigos.remover();

                    //Se o tiro não colidiu com o boneco, recoloca-o na lista de tiros
                    if (tiro.collided(boneco) == false)
                    {
                        //Adiciona o tiro removido ao final da lista de Tiros
                        tirosInimigos.addTiro(tiro);
                    }
                    else
                    {
                        //O tiro colidiu com o boneco, então executa um som de explosão
                        new Sound("explosao.wav").play();
                        bonecoSofreuTiro =true;
                    }
            }
            return bonecoSofreuTiro;
    }
}
